    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2005, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * --------------
    028     * DialShape.java
    029     * --------------
    030     * (C) Copyright 2003-2005, by Object Refinery Limited.
    031     *
    032     * Original Author:  David Gilbert (for Object Refinery Limited);
    033     * Contributor(s):   -;
    034     *
    035     * $Id: DialShape.java,v 1.4.2.1 2005/10/25 20:52:08 mungady Exp $
    036     *
    037     * Changes:
    038     * --------
    039     * 20-Aug-2003 : Version 1 (DG);
    040     *
    041     */
    042
    043    package org.jfree.chart.plot;
    044
    045    import java.io.ObjectStreamException;
    046    import java.io.Serializable;
    047
    048    /**
    049     * Used to indicate the background shape for a
    050     * {@link org.jfree.chart.plot.MeterPlot}.
    051     */
    052    public final class DialShape implements Serializable {
    053
    054        /** For serialization. */
    055        private static final long serialVersionUID = -3471933055190251131L;
    056
    057        /** Circle. */
    058        public static final DialShape CIRCLE = new DialShape("DialShape.CIRCLE");
    059
    060        /** Chord. */
    061        public static final DialShape CHORD = new DialShape("DialShape.CHORD");
    062
    063        /** Pie. */
    064        public static final DialShape PIE = new DialShape("DialShape.PIE");
    065
    066        /** The name. */
    067        private String name;
    068
    069        /**
    070         * Private constructor.
    071         *
    072         * @param name  the name.
    073         */
    074        private DialShape(String name) {
    075            this.name = name;
    076        }
    077
    078        /**
    079         * Returns a string representing the object.
    080         *
    081         * @return The string.
    082         */
    083        public String toString() {
    084            return this.name;
    085        }
    086
    087        /**
    088         * Returns <code>true</code> if this object is equal to the specified
    089         * object, and <code>false</code> otherwise.
    090         *
    091         * @param obj  the other object.
    092         *
    093         * @return A boolean.
    094         */
    095        public boolean equals(Object obj) {
    096            if (this == obj) {
    097                return true;
    098            }
    099            if (!(obj instanceof DialShape)) {
    100                return false;
    101            }
    102            DialShape shape = (DialShape) obj;
    103            if (!this.name.equals(shape.toString())) {
    104                return false;
    105            }
    106            return true;
    107        }
    108
    109        /**
    110         * Ensures that serialization returns the unique instances.
    111         *
    112         * @return The object.
    113         *
    114         * @throws ObjectStreamException if there is a problem.
    115         */
    116        private Object readResolve() throws ObjectStreamException {
    117            if (this.equals(DialShape.CIRCLE)) {
    118                return DialShape.CIRCLE;
    119            }
    120            else if (this.equals(DialShape.CHORD)) {
    121                return DialShape.CHORD;
    122            }
    123            else if (this.equals(DialShape.PIE)) {
    124                return DialShape.PIE;
    125            }
    126            return null;
    127        }
    128
    129    }